=== modified file 'ChangeLog'
--- ChangeLog	2006-08-03 11:45:19 +0000
+++ ChangeLog	2006-08-03 14:32:03 +0000
@@ -1,5 +1,7 @@
 2006-08-03  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
+    * olive/frontend/gtk/status.py: Status window implemented
+    * olive.glade: Status window designed and Branch/status menu added
     * olive.glade: added Statistics menu
     * olive/frontend/gtk/__init__.py: added Statistics menu handlers
     * olive/frontend/gtk/handler.py: implemented Diff menu handler

=== modified file 'olive.glade'
--- olive.glade	2006-08-03 11:45:19 +0000
+++ olive.glade	2006-08-03 14:32:03 +0000
@@ -51,7 +51,7 @@
 		      <signal name="activate" handler="on_menuitem_add_files_activate" last_modification_time="Fri, 21 Jul 2006 11:38:39 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image98">
+			<widget class="GtkImage" id="image106">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-add</property>
 			  <property name="icon_size">1</property>
@@ -72,7 +72,7 @@
 		      <signal name="activate" handler="on_menuitem_remove_file_activate" last_modification_time="Fri, 21 Jul 2006 13:54:07 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image99">
+			<widget class="GtkImage" id="image107">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-remove</property>
 			  <property name="icon_size">1</property>
@@ -193,7 +193,7 @@
 		      <signal name="activate" handler="on_menuitem_branch_pull_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image100">
+			<widget class="GtkImage" id="image108">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-goto-bottom</property>
 			  <property name="icon_size">1</property>
@@ -214,7 +214,7 @@
 		      <signal name="activate" handler="on_menuitem_branch_push_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image101">
+			<widget class="GtkImage" id="image109">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-goto-top</property>
 			  <property name="icon_size">1</property>
@@ -241,7 +241,7 @@
 		      <signal name="activate" handler="on_menuitem_branch_commit_activate" last_modification_time="Mon, 17 Jul 2006 08:53:37 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image102">
+			<widget class="GtkImage" id="image110">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-redo</property>
 			  <property name="icon_size">1</property>
@@ -253,6 +253,21 @@
 		      </child>
 		    </widget>
 		  </child>
+
+		  <child>
+		    <widget class="GtkSeparatorMenuItem" id="separator_branch3">
+		      <property name="visible">True</property>
+		    </widget>
+		  </child>
+
+		  <child>
+		    <widget class="GtkMenuItem" id="menuitem_branch_status">
+		      <property name="visible">True</property>
+		      <property name="label" translatable="yes">S_tatus...</property>
+		      <property name="use_underline">True</property>
+		      <signal name="activate" handler="on_menuitem_branch_status_activate" last_modification_time="Thu, 03 Aug 2006 13:58:03 GMT"/>
+		    </widget>
+		  </child>
 		</widget>
 	      </child>
 	    </widget>
@@ -2272,4 +2287,89 @@
   </child>
 </widget>
 
+<widget class="GtkWindow" id="window_status">
+  <property name="width_request">400</property>
+  <property name="height_request">300</property>
+  <property name="visible">True</property>
+  <property name="title" translatable="yes">Olive - Status</property>
+  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="window_position">GTK_WIN_POS_NONE</property>
+  <property name="modal">False</property>
+  <property name="resizable">True</property>
+  <property name="destroy_with_parent">False</property>
+  <property name="icon">oliveicon2.png</property>
+  <property name="decorated">True</property>
+  <property name="skip_taskbar_hint">False</property>
+  <property name="skip_pager_hint">False</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_NORMAL</property>
+  <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
+  <property name="focus_on_map">True</property>
+  <property name="urgency_hint">False</property>
+
+  <child>
+    <widget class="GtkVBox" id="vbox_status">
+      <property name="border_width">5</property>
+      <property name="visible">True</property>
+      <property name="homogeneous">False</property>
+      <property name="spacing">3</property>
+
+      <child>
+	<widget class="GtkScrolledWindow" id="scrolledwindow_status">
+	  <property name="visible">True</property>
+	  <property name="can_focus">True</property>
+	  <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
+	  <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
+	  <property name="shadow_type">GTK_SHADOW_IN</property>
+	  <property name="window_placement">GTK_CORNER_TOP_LEFT</property>
+
+	  <child>
+	    <widget class="GtkTreeView" id="treeview_status">
+	      <property name="visible">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="headers_visible">False</property>
+	      <property name="rules_hint">False</property>
+	      <property name="reorderable">False</property>
+	      <property name="enable_search">True</property>
+	      <property name="fixed_height_mode">False</property>
+	      <property name="hover_selection">False</property>
+	      <property name="hover_expand">False</property>
+	    </widget>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">True</property>
+	  <property name="fill">True</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkHButtonBox" id="hbuttonbox_status">
+	  <property name="visible">True</property>
+	  <property name="layout_style">GTK_BUTTONBOX_DEFAULT_STYLE</property>
+	  <property name="spacing">0</property>
+
+	  <child>
+	    <widget class="GtkButton" id="button_status_close">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label">gtk-close</property>
+	      <property name="use_stock">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_status_close_clicked" last_modification_time="Thu, 03 Aug 2006 13:45:17 GMT"/>
+	    </widget>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">True</property>
+	</packing>
+      </child>
+    </widget>
+  </child>
+</widget>
+
 </glade-interface>

=== modified file 'olive/backend/fileops.py'
--- olive/backend/fileops.py	2006-08-01 16:16:31 +0000
+++ olive/backend/fileops.py	2006-08-03 14:32:03 +0000
@@ -1,17 +1,17 @@
 # Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
 # Some parts of the code are:
 # Copyright (C) 2005, 2006 by Canonical Ltd
-
+#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-
+#
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-
+#
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
@@ -91,6 +91,7 @@
     
     :param new: if True, the 'added' files will be removed
     """
+    import bzrlib
     from bzrlib.builtins import tree_files
     
     try:
@@ -105,8 +106,12 @@
             raise NoFilesSpecified
     else:
         from bzrlib.delta import compare_trees
-        added = [compare_trees(tree.basis_tree(), tree,
-                               specific_files=file_list).added]
+        if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
+            added = [compare_trees(tree.basis_tree(), tree,
+                                   specific_files=file_list).added]
+        else:
+            added = [tree.changes_from(tree.basis_tree(),
+                                       specific_files=file_list).added]
         file_list = sorted([f[0] for f in added[0]], reverse=True)
         if len(file_list) == 0:
             raise NoMatchingFiles

=== modified file 'olive/frontend/gtk/__init__.py'
--- olive/frontend/gtk/__init__.py	2006-08-03 11:45:19 +0000
+++ olive/frontend/gtk/__init__.py	2006-08-03 14:32:03 +0000
@@ -1,15 +1,15 @@
 # Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-
+#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-
+#
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-
+#
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
@@ -66,6 +66,8 @@
                 "on_menuitem_branch_checkout_activate": handler.on_menuitem_branch_checkout_activate,
                 "on_menuitem_branch_commit_activate": handler.on_menuitem_branch_commit_activate,
                 "on_menuitem_branch_push_activate": handler.on_menuitem_branch_push_activate,
+                "on_menuitem_branch_pull_activate": handler.not_implemented,
+                "on_menuitem_branch_status_activate": handler.on_menuitem_branch_status_activate,
                 "on_menuitem_stats_diff_activate": handler.on_menuitem_stats_diff_activate,
                 "on_menuitem_stats_log_activate": handler.not_implemented,
                 "on_menuitem_stats_infos_activate": handler.not_implemented,

=== modified file 'olive/frontend/gtk/diff.py'
--- olive/frontend/gtk/diff.py	2006-08-03 10:14:44 +0000
+++ olive/frontend/gtk/diff.py	2006-08-03 14:32:03 +0000
@@ -43,7 +43,7 @@
 
 import bzrlib
 
-if bzrlib.version_info[1] < 9:
+if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
     # function deprecated after 0.9
     from bzrlib.delta import compare_trees
 
@@ -140,7 +140,7 @@
     def _init_diff(self):
         """ Generate initial diff. """
         self.model.clear()
-        if bzrlib.version_info[1] < 9:
+        if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
             delta = compare_trees(self.old_tree, self.wt)
         else:
             delta = self.wt.changes_from(self.old_tree)

=== modified file 'olive/frontend/gtk/handler.py'
--- olive/frontend/gtk/handler.py	2006-08-03 11:45:19 +0000
+++ olive/frontend/gtk/handler.py	2006-08-03 14:32:03 +0000
@@ -1,15 +1,15 @@
 # Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-
+#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; either version 2 of the License, or
 # (at your option) any later version.
-
+#
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
-
+#
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
@@ -38,6 +38,7 @@
 from menu import OliveMenu
 from push import OlivePush
 from remove import OliveRemove
+from status import OliveStatus
 
 class OliveHandler:
     """ Signal handler class for Olive. """
@@ -77,6 +78,11 @@
         push = OlivePush(self.gladefile, self.comm)
         push.display()
     
+    def on_menuitem_branch_status_activate(self, widget):
+        """ Branch/Status... menu handler. """
+        status = OliveStatus(self.gladefile, self.comm)
+        status.display()
+    
     def on_menuitem_branch_initialize_activate(self, widget):
         """ Initialize current directory. """
         import olive.backend.init as init

=== added file 'olive/frontend/gtk/status.py'
--- olive/frontend/gtk/status.py	1970-01-01 00:00:00 +0000
+++ olive/frontend/gtk/status.py	2006-08-03 14:32:03 +0000
@@ -0,0 +1,142 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import sys
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+try:
+    import gtk
+    import gtk.glade
+    import gobject
+    import pango
+except:
+    sys.exit(1)
+
+import bzrlib
+
+if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
+    # function deprecated after 0.9
+    from bzrlib.delta import compare_trees
+
+from bzrlib.status import show_tree_status
+from bzrlib.workingtree import WorkingTree
+
+from dialog import OliveDialog
+
+class OliveStatus:
+    """ Display Status window and perform the needed actions. """
+    def __init__(self, gladefile, comm):
+        """ Initialize the Diff window. """
+        self.gladefile = gladefile
+        self.glade = gtk.glade.XML(self.gladefile, 'window_status')
+        
+        self.comm = comm
+        
+        self.dialog = OliveDialog(self.gladefile)
+        
+        # Check if current location is a branch
+        try:
+            (self.wt, path) = WorkingTree.open_containing(self.comm.get_path())
+            branch = self.wt.branch
+        except errors.NotBranchError:
+            self.notbranch = True
+            return
+        except:
+            raise
+        
+        file_id = self.wt.path2id(path)
+
+        self.notbranch = False
+        if file_id is None:
+            self.notbranch = True
+            return
+        
+        # Set the old working tree
+        self.old_tree = self.wt.branch.repository.revision_tree(self.wt.branch.last_revision())
+        
+        # Get the Diff window widget
+        self.window = self.glade.get_widget('window_status')
+        
+        # Dictionary for signal_autoconnect
+        dic = { "on_button_status_close_clicked": self.close }
+        
+        # Connect the signals to the handlers
+        self.glade.signal_autoconnect(dic)
+        
+        # Generate status output
+        self._generate_status()
+
+    def _generate_status(self):
+        """ Generate 'bzr status' output. """
+        self.model = gtk.TreeStore(str, str)
+        self.treeview = self.glade.get_widget('treeview_status')
+        self.treeview.set_model(self.model)
+        
+        cell = gtk.CellRendererText()
+        cell.set_property("width-chars", 20)
+        column = gtk.TreeViewColumn()
+        column.pack_start(cell, expand=True)
+        column.add_attribute(cell, "text", 0)
+        self.treeview.append_column(column)
+        
+        if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
+            delta = compare_trees(self.old_tree, self.wt)
+        else:
+            delta = self.wt.changes_from(self.old_tree)
+
+        if len(delta.added):
+            titer = self.model.append(None, [ "Added", None ])
+            for path, id, kind in delta.added:
+                self.model.append(titer, [ path, path ])
+
+        if len(delta.removed):
+            titer = self.model.append(None, [ "Removed", None ])
+            for path, id, kind in delta.removed:
+                self.model.append(titer, [ path, path ])
+
+        if len(delta.renamed):
+            titer = self.model.append(None, [ "Renamed", None ])
+            for oldpath, newpath, id, kind, text_modified, meta_modified \
+                    in delta.renamed:
+                self.model.append(titer, [ oldpath, newpath ])
+
+        if len(delta.modified):
+            titer = self.model.append(None, [ "Modified", None ])
+            for path, id, kind, text_modified, meta_modified in delta.modified:
+                self.model.append(titer, [ path, path ])
+        
+        done_unknown = False
+        for path in self.wt.unknowns():
+            if not done_unknown:
+                titer = self.model.append(None, [ "Unknown", None ])
+                done_unknown = True
+            self.model.append(titer, [ path, path ])
+
+        self.treeview.expand_all()
+    
+    def display(self):
+        """ Display the Diff window. """
+        if self.notbranch:
+            self.dialog.error_dialog('Directory is not a branch.')
+        else:
+            self.window.show_all()
+
+    def close(self, widget=None):
+        self.window.destroy()

